<?php
/**
 * Custom page walker for this theme.
 *
 * @package Multi Sports Club
 */

if (!class_exists('Multi_Sports_Club_Walker_Page')) {
    /**
     * CUSTOM PAGE WALKER
     * A custom walker for pages.
     */
    class Multi_Sports_Club_Walker_Page extends Walker_Page
    {

        /**
         * Outputs the beginning of the current element in the tree.
         *
         * @param string $multi_sports_club_output Used to append additional content. Passed by reference.
         * @param WP_Post $page Page data object.
         * @param int $multi_sports_club_depth Optional. Depth of page. Used for padding. Default 0.
         * @param array $multi_sports_club_args Optional. Array of arguments. Default empty array.
         * @param int $current_page Optional. Page ID. Default 0.
         * @since 2.1.0
         *
         * @see Walker::start_el()
         */

        public function start_lvl( &$multi_sports_club_output, $multi_sports_club_depth = 0, $multi_sports_club_args = array() ) {
            $multi_sports_club_indent  = str_repeat( "\t", $multi_sports_club_depth );
            $multi_sports_club_output .= "$multi_sports_club_indent<ul class='sub-menu'>\n";
        }

        public function start_el(&$multi_sports_club_output, $page, $multi_sports_club_depth = 0, $multi_sports_club_args = array(), $current_page = 0)
        {

            if (isset($multi_sports_club_args['item_spacing']) && 'preserve' === $multi_sports_club_args['item_spacing']) {
                $t = "\t";
                $n = "\n";
            } else {
                $t = '';
                $n = '';
            }
            if ($multi_sports_club_depth) {
                $multi_sports_club_indent = str_repeat($t, $multi_sports_club_depth);
            } else {
                $multi_sports_club_indent = '';
            }

            $multi_sports_club_css_class = array('page_item', 'page-item-' . $page->ID);

            if (isset($multi_sports_club_args['pages_with_children'][$page->ID])) {
                $multi_sports_club_css_class[] = 'page_item_has_children';
            }

            if (!empty($current_page)) {
                $_current_page = get_post($current_page);
                if ($_current_page && in_array($page->ID, $_current_page->ancestors, true)) {
                    $multi_sports_club_css_class[] = 'current_page_ancestor';
                }
                if ($page->ID === $current_page) {
                    $multi_sports_club_css_class[] = 'current_page_item';
                } elseif ($_current_page && $page->ID === $_current_page->post_parent) {
                    $multi_sports_club_css_class[] = 'current_page_parent';
                }
            } elseif (get_option('page_for_posts') === $page->ID) {
                $multi_sports_club_css_class[] = 'current_page_parent';
            }

            /** This filter is documented in wp-includes/class-walker-page.php */
            $multi_sports_club_css_classes = implode(' ', apply_filters('page_css_class', $multi_sports_club_css_class, $page, $multi_sports_club_depth, $multi_sports_club_args, $current_page));
            $multi_sports_club_css_classes = $multi_sports_club_css_classes ? ' class="' . esc_attr($multi_sports_club_css_classes) . '"' : '';

            if ('' === $page->post_title) {
                /* translators: %d: ID of a post. */
                $page->post_title = sprintf(__('#%d (no title)', 'multi-sports-club'), $page->ID);
            }

            $multi_sports_club_args['link_before'] = empty($multi_sports_club_args['link_before']) ? '' : $multi_sports_club_args['link_before'];
            $multi_sports_club_args['link_after'] = empty($multi_sports_club_args['link_after']) ? '' : $multi_sports_club_args['link_after'];

            $multi_sports_club_atts = array();
            $multi_sports_club_atts['href'] = get_permalink($page->ID);
            $multi_sports_club_atts['aria-current'] = ($page->ID === $current_page) ? 'page' : '';

            /** This filter is documented in wp-includes/class-walker-page.php */
            $multi_sports_club_atts = apply_filters('page_menu_link_attributes', $multi_sports_club_atts, $page, $multi_sports_club_depth, $multi_sports_club_args, $current_page);

            $multi_sports_club_attributes = '';
            foreach ($multi_sports_club_atts as $attr => $multi_sports_club_value) {
                if (!empty($multi_sports_club_value)) {
                    $multi_sports_club_value = ('href' === $attr) ? esc_url($multi_sports_club_value) : esc_attr($multi_sports_club_value);
                    $multi_sports_club_attributes .= ' ' . $attr . '="' . $multi_sports_club_value . '"';
                }
            }

            $multi_sports_club_args['list_item_before'] = '';
            $multi_sports_club_args['list_item_after'] = '';
            $multi_sports_club_args['icon_rennder'] = '';
            // Wrap the link in a div and append a sub menu toggle.
            if (isset($multi_sports_club_args['show_toggles']) && true === $multi_sports_club_args['show_toggles']) {
                // Wrap the menu item link contents in a div, used for positioning.
                $multi_sports_club_args['list_item_after'] = '';
            }


            // Add icons to menu items with children.
            if (isset($multi_sports_club_args['show_sub_menu_icons']) && true === $multi_sports_club_args['show_sub_menu_icons']) {
                if (isset($multi_sports_club_args['pages_with_children'][$page->ID])) {
                    $multi_sports_club_args['icon_rennder'] = '';
                }
            }

            // Add icons to menu items with children.
            if (isset($multi_sports_club_args['show_toggles']) && true === $multi_sports_club_args['show_toggles']) {
                if (isset($multi_sports_club_args['pages_with_children'][$page->ID])) {

                    $toggle_target_string = '.page_item.page-item-' . $page->ID . ' > .sub-menu';

                    $multi_sports_club_args['list_item_after'] = '<button type="button" class="theme-aria-button submenu-toggle" data-toggle-target="' . $toggle_target_string . '" data-toggle-type="slidetoggle" data-toggle-duration="250"><span class="btn__content" tabindex="-1"><span class="screen-reader-text">' . __( 'Show sub menu', 'multi-sports-club' ) . '</span>' . multi_sports_club_get_theme_svg( 'chevron-down' ) . '</span></button>';
                }
            }

            if (isset($multi_sports_club_args['show_toggles']) && true === $multi_sports_club_args['show_toggles']) {

                $multi_sports_club_output .= $multi_sports_club_indent . sprintf(
                        '<li%s>%s%s<a%s>%s%s%s</a>%s%s',
                        $multi_sports_club_css_classes,
                        '<div class="submenu-wrapper">',
                        $multi_sports_club_args['list_item_before'],
                        $multi_sports_club_attributes,
                        $multi_sports_club_args['link_before'],
                        /** This filter is documented in wp-includes/post-template.php */
                        apply_filters('the_title', $page->post_title, $page->ID),
                        $multi_sports_club_args['link_after'],
                        $multi_sports_club_args['list_item_after'],
                        '</div>'
                    );

            }else{

                $multi_sports_club_output .= $multi_sports_club_indent . sprintf(
                        '<li%s>%s<a%s>%s%s%s%s</a>%s',
                        $multi_sports_club_css_classes,
                        $multi_sports_club_args['list_item_before'],
                        $multi_sports_club_attributes,
                        $multi_sports_club_args['link_before'],
                        /** This filter is documented in wp-includes/post-template.php */
                        apply_filters('the_title', $page->post_title, $page->ID),
                        $multi_sports_club_args['icon_rennder'],
                        $multi_sports_club_args['link_after'],
                        $multi_sports_club_args['list_item_after']
                    );

            }

            if (!empty($multi_sports_club_args['show_date'])) {
                if ('modified' === $multi_sports_club_args['show_date']) {
                    $multi_sports_club_time = $page->post_modified;
                } else {
                    $multi_sports_club_time = $page->post_date;
                }

                $multi_sports_club_date_format = empty($multi_sports_club_args['date_format']) ? '' : $multi_sports_club_args['date_format'];
                $multi_sports_club_output .= ' ' . mysql2date($multi_sports_club_date_format, $multi_sports_club_time);
            }
        }
    }
}